// arrow.cpp
//
// Priklad pretizeneho operatoru ->
// Trida p_datum zapouzdruje ukazatel na strukturu datum
// a zprostredkovava pristup k ni prostrednictvim pretizeneho
// operatoru ->
// Destruktor teto tridy pri zaniku instance automaticky 
// uvolni strukturu, na kterou instance ukazuje

#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <iostream>
using namespace std;

struct datum {
	int den, mesic, rok;
	datum(int d, int m, int r) : den(d), mesic(m), rok(r) {}
};

class p_datum {
	datum* p;
public:
	p_datum(datum* pd) : p(pd) {}
	~p_datum() { delete p; }
	datum* operator->() { return p; }
};

void my_getch();

int main()
{
	p_datum d = new datum(11, 12, 2000);
	// Nemusime se starat o zruseni
	cout << endl << d->den << " " << d->mesic << " " << d->rok << endl;
	my_getch();
	return 0;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------